/* $Id: ResourceManager.java,v 1.5 2005/08/26 04:45:03 ysahara Exp $
*
* Copyright (c)ARGO 21, Corporation. 2005.  All rights reserved.
 * 
 * This file is part of Nautica Workflow.
 * 
 *  Nautica Workflow is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 * 
 *  Nautica Workflow is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *  You should have received a copy of the GNU General Public License
 *  along with Nautica Workflow; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *  
*/
package jp.co.argo21.nautica.workflow.sample.util;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ResourceBundle;

import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.sql.DataSource;

/**
 * リソースに対してアクセスするクラスである。
 * このクラスがアクセスするリソースは以下の２つである。
 * ・データソース・リソース
 * 		このクラスはMySqlのJNDI名を指定する。Tomcatの機能を用いてデータソース
 * 		オブジェクトを取得する。また、取得したデータソースオブジェクトから得る
 * 		コネクションオブジェクトのオープンとクローズをする。
 * 
 * ・リソースバンドル・リソース
 * 		このクラスはメール設定用のリソースバンドルのパスを指定する。
 * 		そして、メール設定情報を取得する。
 * 
 * @author  ruchida(Argo 21, Corp.)
 * @version $Revision: 1.5 $
 * @since   Nautica Workflow 0.9
 */
public class ResourceManager {
    
    /** MySQL 用 の DataSource を取得するための JNDI 名 */
	private static final String MYSQL_JNDI = "java:comp/env/jdbc/mysql";
    
    /** ResourceBundle オブジェクト */
    private static final ResourceBundle bundle 
            = ResourceBundle.getBundle("jp.co.argo21.nautica.workflow.sample.resource.ApplicationResources");
    
    /** 自身のインスタンス */
	private static ResourceManager locator = new ResourceManager();
	
    /** InitialContext オブジェクト */
	private InitialContext context = null;
    
    /** DataSource オブジェクト */
	private DataSource source = null;
	
    /**
     * デフォルトコンストラクタ。
     * シングルトンであるため、private として宣言する。
     */
	private ResourceManager() {
		try {
			context = new InitialContext();
			source = (DataSource) context.lookup(MYSQL_JNDI);
            
		} catch(NamingException e) {
            // 投げても意味がないため、標準出力に表示する
            System.err.println(e.getMessage());
		}
	}
	
    /**
     * ResourceManager のインスタンスを取得する。
     * 
     * @return ResourceManager のインスタンス
     */
	public static ResourceManager getInstance() {
		return locator;
	}
	
    /**
     * データベースコネクションを取得する。
     * 
     * @return データベースコネクション
     * @throws SQLException
     */
	public Connection getConnection() throws SQLException {
    	return source.getConnection();	
	}
	
    /**
     * データベースコネクションを閉じる。
     * 
     * @param conn コネクションオブジェクト
     * @param stmt ステートメントオブジェクト
     * @throws SQLException 任意のSQL例外
     */
	public void closeConnection(Connection conn, Statement stmt) throws SQLException {
		if (stmt != null) {
			stmt.close();
		}
		if ( (conn != null) && (!conn.isClosed())) {		
			conn.close();
		}
	}
    
    public void closeConnection(Connection conn) throws SQLException {
        if ( (conn != null) && (!conn.isClosed())) {        
            conn.close();
        }
    }

    /**
     * プロパティファイルに設定された key に対応する value を返す。
     * 
     * @param key プロパティファイルの key となる文字列
     * @return key に対応する value
     */
    public String getValue(String key) {
        return bundle.getString(key);
    }
}
